// EVNEW - Escape Velocity: Nova Editor for Windows
// By Adam Rosenfield
// (c) 2003 All Rights Reserved

// File CBitFieldControl.h

#ifndef CBITFIELDCONTROL_H_INCLUDED		// Prevent multiple inclusions
#define CBITFIELDCONTROL_H_INCLUDED

////////////////////////////////////////////////////////////////
///////////////////////  CLASS FORWARDS  ///////////////////////
////////////////////////////////////////////////////////////////

class CBitFieldControl;

////////////////////////////////////////////////////////////////
//////////////////////////	INCLUDES  //////////////////////////
////////////////////////////////////////////////////////////////

#include <windows.h>

#include "CWindow.h"

#include "CNovaResource.h"

#include "CControl.h"

#include "Utils.h"

////////////////////////////////////////////////////////////////
//////////////////////////  CONSTANTS  /////////////////////////
////////////////////////////////////////////////////////////////

const int NUM_CBITFIELDCONTROL_CONTROLS = 64;

////////////////////////////////////////////////////////////////
///////////////////////////  CLASSES  //////////////////////////
////////////////////////////////////////////////////////////////

class CBitFieldControl
{
public:
	CBitFieldControl(void);
	~CBitFieldControl(void);

	int DoDialog(CWindow *pWndParent, int iNumBits, char *pValue);

private:

	int InitializeControls(HWND hwnd);
	int CloseAndSave(void);
	int CloseAndDontSave(void);

	static BOOL BitFieldControlDlgProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);

	CWindow m_wndBits;

	int m_iNumBits;

	char m_cValue[8];

	CControl m_controls[NUM_CBITFIELDCONTROL_CONTROLS];
};

#endif		// #ifndef CBITFIELDCONTROL_H_INCLUDED
